Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic
Imports GTA

Public Class NeonScript
    Inherits Script

    Public Offset1 As New Vector3(-0.5F, 0.0F, -1.0F)
    Public Offset2 As New Vector3(0.5F, 0.0F, -1.0F)
    Public Offset3 As New Vector3(0.0F, 1.75F, -1.0F)
    Public Offset4 As New Vector3(0.0F, -1.75F, -1.0F)
    Public ZOffset As Single = 0.25F
    Public Z1000 As New Vector3(0.0F, 0.0F, 5.0F)

    Private Sub NeonScript_ConsoleCommand(ByVal sender As Object, ByVal e As GTA.ConsoleEventArgs) Handles Me.ConsoleCommand
        If e.Command.ToLower <> "neon" Then Return
        If Not Player.Character.isSittingInVehicle Then Return
        Dim val As String = e.Parameter.ToString(0).ToLower
        Select Case val
            Case "red"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFFFF0000)
            Case "green"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFF00FF00)
            Case "blue"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFF0000FF)
            Case "pink"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFFFF00FF)
		    Case "orange"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFFFF8400)
			Case "purple"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFF8400FF)
			Case "turquoise"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFF00FFCC)
			Case "yellow"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFFFFF000)
			Case "white"
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, &HFFFFFFFF)
            Case Else
                Player.Character.CurrentVehicle.SetMetadata("neon_light_color", True, HexToInteger(val))
        End Select
    End Sub

    Private Function HexToInteger(ByVal hex As String) As Integer
        Try
            Return Convert.ToInt32(hex, 16)
        Catch ex As Exception
            Return 0
        End Try
    End Function

    Private Sub NeonScript_PerFrameDrawing(ByVal sender As Object, ByVal e As GTA.GraphicsEventArgs) Handles Me.PerFrameDrawing
        If Not Player.Character.isSittingInVehicle Then Return
        Dim v As Vehicle = Player.Character.CurrentVehicle
        If v Is Nothing Then Return
        Dim col As Integer = v.GetMetadata(Of Integer)("neon_light_color", True)
        If col = 0 Then Return
        Dim dcol As Drawing.Color = Drawing.Color.FromArgb(col)

        DrawLight(v, e.Graphics, dcol, Offset1, 3.0F)
        DrawLight(v, e.Graphics, dcol, Offset2, 3.0F)
        DrawLight(v, e.Graphics, dcol, Offset3, 1.5F)
        DrawLight(v, e.Graphics, dcol, Offset4, 1.5F)
    End Sub

    Private Sub DrawLight(ByVal v As Vehicle, ByVal g As Graphics, ByVal Color As Drawing.Color, ByVal Offset As Vector3, ByVal Radius As Single)
        Dim pos As Vector3 = FixZ(v.GetOffsetPosition(Offset))
        g.DrawLight(pos, Color, Radius, 40)
    End Sub

    Private Function FixZ(ByVal Position As Vector3) As Vector3
        Dim G As Single = World.GetGroundZ(Position + Z1000) + ZOffset
        If Position.Z < G Then Position.Z = G
        Return Position
    End Function

End Class